# -*- coding: utf-8 -*-
# Algorithmus_von_Prim_original_mit_Ausgaben.py

# Wartezeit bei der Ausgabe
warte_sec=0.1

from Graphenprojekt import *
cont=Controller()

### kleiner Graph:
### Knotenliste muss beide Richtungen beinhalten!
##graph={'A': [['B', '27'], ['E', '18']],
##       'B': [['A', '27'], ['C', '12'], ['F', '12']],
##       'C': [['B', '12'], ['D', '18'], ['F', '16']],
##       'D': [['C', '18'], ['E', '36'], ['F', '16']],
##       'E': [['A', '18'], ['D', '36'], ['F', '25']],
##       'F': [['B', '12'], ['C', '16'], ['D', '16'], ['E', '25']]
##    }

graph=cont.gibKantenDict()
print(graph)

# ----- kuerzer -----
def kuerzer(kante1, kante2):
    return  (kante1[2] < kante2[2])

# ----- ordneEin -----
# sortiert durch Einfügen
def ordneEin(kante, sortierte):
    for index in range(len(sortierte)):
        if kuerzer(kante, sortierte[index]):
            sortierte[index:index]=[kante]
            return sortierte
    sortierte[len(sortierte):len(sortierte)]=[kante]
    return sortierte

def nachfolgeKanten(ecke, graph):
    kanten=[]
    nachfolger=graph[ecke]
    for nach in nachfolger:
        kanten+=[[ecke]+nach]
    return kanten

# ----- Der eigentliche Algorithmus -----
# Aufrufhülle für die Rekursion
def AvPrim(graph, startEcke):
    baum=[]
    enthalteneEcken=[startEcke]
    neueEcke=startEcke
    cont.aendereFuellFarbe(Knoten,neueEcke,'red')
    prioSchlange=[]
    while len(enthalteneEcken)<len(graph):
        print( '\nDer Baum ist bisher:', baum )
        print( 'Neue Ecke ist:', neueEcke )
        ### Darstellung:
        for kante in nachfolgeKanten(neueEcke, graph):
            print( 'Die Kante in ProWS einfügen:', kante )
            prioSchlange=ordneEin(kante, prioSchlange)
        print( 'PrioSchlange ist jetzt:', prioSchlange )
        # Entferne alle Zyklen:
        temp=[]
        for kante in prioSchlange:
            print( 'Zyklentest der Kante', kante )
            if not (kante[0] in enthalteneEcken):
                temp.append(kante)
            elif not (kante[1] in enthalteneEcken):
                temp.append(kante)
            elif enthaeltRueckKante(baum, kante):
                print('Kante ist Rueckkante')
            else:
                # kante bildet Zyklus
                print(kante,' erzeugt einen Zyklus' )
                cont.aendereRandFarbe(Kante,kante[0],
                                      'gray',kante[1])        
        prioSchlange=temp
        # Die erste Kante setzt den Baum minimal fort
        print( 'Die erste Kante kann eingebaut werden:',prioSchlange[0] )
        baum.append(prioSchlange[0])
        cont.aendereRandFarbe(Kante,prioSchlange[0][0],'blue',
                              prioSchlange[0][1])
        if prioSchlange[0][0] in enthalteneEcken:
            enthalteneEcken.append(prioSchlange[0][1])
            neueEcke=prioSchlange[0][1]
        else:
            enthalteneEcken.append(prioSchlange[0][0])
            neueEcke=prioSchlange[0][0]
        print( 'Neue Ecke ist:', neueEcke )
        print( 'Baum:', baum )
        cont.aendereFuellFarbe(Knoten,neueEcke,'red')
        cont.warte(warte_sec)
        #input('Knoten'+neueEcke)
        prioSchlange.remove(prioSchlange[0])
        print( 'PrioSchlange ist jetzt:', prioSchlange )
    for element in prioSchlange:
        cont.aendereRandFarbe(Kante,element[0],'gray',element[1])        
    return baum

def enthaeltRueckKante(baum, dieKante):
    for kante in baum:
        if kante[0]==dieKante[1] and kante[1]==dieKante[0]:
            return True
    return False

### ===== Testaufruf =====
AvPrim(graph, 'A')
